;Tortoise v0.1
; (C) 2007 by Michael Vincent and Brandon Wilson
;This is a TI-73 Flash application shell similar to Mallard which will execute all Mallard-compatible assembly programs, as well as enhance the OS in several ways.
;Future plans:
; Many hooks to improve upon the OS
; Embedding variables within the application, moving them back and forth, and garbage collecting to create a "user archive" of ~8KB

;v0.1 Changelog
;Initial release

 include "settings.inc"
 NOLIST
 include "ti73.inc"
 LIST
 include "equates.inc"
 include "header.asm"

 SEGMENT MAIN
 GLOBALS ON

 EXTERN PutSApp,IPutS,IGetKey,VPutSApp,VPutSAppCenter,BHL_plus_DE,getAppNameLen

;any of this necessary?
;-------------------------------------------
 Var prgmCur,1
 Var prgmCount,1
 Var prgmTop,2
 Var tempWord,2
 Var randData,2

prgmRunning		equ statVars+200
lastVar 		equ statVars+202
;-------------------------------------------

StartApp:
	B_CALL DelRes
Shell_Restart:
	set noPrograms,(iy+tortoiseFlags)
	ld hl,(progPtr)
	call findNextPrgm
	jr z,Shell_Redisplay
	res noPrograms,(iy+tortoiseFlags)
	ld (prgmTop),hl
Shell_Redisplay:
	B_CALL ClrLCDFull
	ld hl,1
	ld (penCol),hl
	ld hl,sTitle
	call VPutSApp
	ld bc,56
	ld de,95*256+56
	B_CALL DarkLine
	bit noPrograms,(iy+tortoiseFlags)
	jr nz,mainKeyLoop
	call DisplayList
	call HighlightPrgm
mainKeyLoop:
	B_CALL GetCSC
	cp skMode
	jr z,doSettings
	cp skClear
	jr z,ExitApp
	bit noPrograms,(iy+tortoiseFlags)
	jr nz,mainKeyLoop
	;up/down/left/right/enter/2nd checks
	cp sk2nd
	jr z,runProgram
	cp skEnter
	jr z,runProgram
	cp skUp
	jr z,Shell_Up
	cp skDown
	jr z,Shell_Down
	cp skLeft
	jr z,Shell_Left
	cp skRight
	jr z,Shell_Right
	jr mainKeyLoop
ExitApp:
	B_CALL ClrLCDFull
	set 6,(iy+32h) ;don't use funky context jump
	set 4,(iy+33h) ;keep hooks active
	set grfNoCoord,(iy+grfDBFlags) ;don't display graph coordinates anywhere
	B_JUMP JForceCmdNoChar
sTitle:
	DB "Tortoise v0.1",0
doSettings:
	B_CALL ClrLCDFull
settingsKeyLoop:
	B_CALL GetCSC
	cp skMode
	jr z,ExitApp
	cp skClear
	jr z,StartApp
	jr settingsKeyLoop

HighlightPrgm:
	ld a,(prgmCur)
	ld b,a
	inc a
	add a,a
	add a,a
	add a,a
	sub b
	ld h,a
	ld l,0
	add a,6
	ld d,a
	ld e,95
	B_CALL InvertRect
	ret
DisplayList:
	xor a
	ld (prgmCur),a
	ld hl,(prgmTop)
	ld b,8
$$:	push bc
	call findNextPrgm
	jr z,$F
	ld h,b
	ld l,c
	pop bc
	push bc
	push hl
	ld hl,10
	add hl,de
	ld a,8
	sub b
	add a,a
	add a,a
	add a,a
	add a,b
	ld d,a
	ld e,1
	ld (penCol),de
	call VPutSApp
	pop hl
	pop bc
	djnz $B
	ld b,0
	push bc
$$:	pop bc
	ld a,8
	sub b
	ld (prgmCount),a
	ret
findNextPrgm:
	ld de,(pTemp)
	or a
	sbc hl,de
	ret z
	add hl,de
	ld a,6
	cp (hl)
	dec hl
	ld e,(hl)
	dec hl
	ld d,(hl)
	dec hl
	ld c,(hl)
	ld b,0
findNextPrgm_Return:
	scf
	jr z,findNextPrgm_Prgm
	sbc hl,bc
	jr findNextPrgm
findNextPrgm_Prgm:
	push hl
	push de
	push bc
	inc de
	inc de
	ld hl,detect
	ld b,6
$$:	ld a,(de)
	cp (hl)
	jr nz,$F
	inc hl
	inc de
	djnz $B
	pop bc
	pop de
	pop hl
	push hl
	scf
	sbc hl,bc
	ld b,h
	ld c,l
	pop hl
	inc hl
	inc hl
	inc hl
	;NZ is set
	ret
$$:	pop bc
	pop de
	pop hl
	jr findNextPrgm_Return
detect:
	DB tStop,0,"Duck"
Shell_Right:
	ld b,9
	ld hl,(prgmTop)
$$:	push bc
	call findNextPrgm
	ex de,hl
	ld h,b
	ld l,c
	pop bc
	jr z,Shell_Restart
	djnz $B
	ld (prgmTop),de
	jr Shell_Redisplay
Shell_Left:
	ld hl,(progPtr)
Shell_Left_1:
	push hl
	ld b,9
Shell_Left_2:
	push bc
	call findNextPrgm
	ld h,b
	ld l,c
	pop bc
	pop de
	jr z,Shell_Restart
	push de
	djnz Shell_Left_2
	pop hl
	ex de,hl
	ld bc,(prgmTop)
	or a
	sbc hl,bc
	jr nc,Shell_Left_Found
	add hl,bc
	jr Shell_Left_1
Shell_Left_Found:
	ld (prgmTop),de
	jr Shell_Redisplay
Shell_Up:
	ld a,(prgmCur)
	or a
	jr z,mainKeyLoop
	call HighlightPrgm
	ld hl,prgmCur
	dec (hl)
	jr Shell_ScrollUpdate
Shell_Down:
	ld a,(prgmCount)
	ld b,a
	ld a,(prgmCur)
	inc a
	cp b
	jr z,mainKeyLoop
	call HighlightPrgm
	ld hl,prgmCur
	inc (hl)
Shell_ScrollUpdate:
	call HighlightPrgm
	jr mainKeyLoop
runProgram:
	ld a,(prgmCur)
	ld b,a
	ld hl,(prgmTop)
	or a
	jr z,Run_Found
$$:	push bc
	call findNextPrgm
	ex de,hl
	ld h,b
	ld l,c
	pop bc
	djnz $B
Run_Found:
	;HL is VAT entry
	ld (prgmRunning),hl
	dec hl
	ld e,(hl)
	dec hl
	ld d,(hl)
	push de
	B_CALL ClrLCDFull
	set graphDraw,(iy+graphFlags)
	res textEraseBelow,(iy+textFlags)
	res textWrite,(iy+textFlags)
	res appTextSave,(iy+sGrFlags)
	ld hl,plotSScreen
	ld (hl),0
	ld de,plotSScreen+1
	ld bc,767
	ldir
	ld hl,ionLibraryVectors
	ld de,statVars
	ld bc,3*8
	ldir
	pop hl
	push hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	;Relocate to userMem
	push bc
	ld hl,RelocationRoutine
	ld de,lastVar+1
	ld bc,Relocation_Routine_End-RelocationRoutine
	ldir
	pop hl
	jp lastVar+1
RelocationRoutine:
	di
	ld (tempWord),hl
	;Normal registers for the insertion
	;Shadow registers for the deletion
	ld de,userMem
	exx
	pop hl
	inc hl
	inc hl
	exx
Relocation_Loop:
	;First copy a chunk
	call Relocation_AdjustLength-RelocationRoutine+lastVar+1
	;HL = length
	push hl
	exx
	pop bc
	push bc
	push hl
	ld de,appBackUpScreen
	ldir
	;Copied to appBackUpScreen
	;Now delete the chunk
	pop hl
	pop de
	push de
	push de
	push hl
	B_CALL DelMem
	pop hl
	pop de
	add hl,de
	exx
	;Now insert memory at the appropriate location
	pop hl
	push hl
	B_CALL InsertMem ;hope DE is intact?
	pop bc
	push bc
	push de
	ld hl,appBackUpScreen
	ldir
	pop de
	pop bc
	ex de,hl
	add hl,bc
	ex de,hl
	;Okay...ready to do it again, but only if there are remaining bytes
	ld bc,(tempWord)
	ld a,b
	or c
	jr nz,Relocation_Loop
	;We are ready for fun...for now, pause
	ld hl,userMem+6
	call 0033h ;_ldhlind
	set 7,h ;for compatibility with DuckIE
	ld de,Relocation_Return-RelocationRoutine+lastVar+1
	push de
	ei
	jp (hl)
Relocation_Return:
	;Now put the program back to its original location
	ld hl,(prgmRunning)
	dec hl
	ld e,(hl)
	dec hl
	ld d,(hl)
	ex de,hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	;BC is the length
	ld (tempWord),bc
	ex de,hl
	;DE is the original address
Relocation_MoveBack_Loop:
	call Relocation_AdjustLength-RelocationRoutine+lastVar+1
	;HL = length
	ld b,h
	ld c,l
	ex de,hl
	or a
	sbc hl,bc
	push hl
	push de
	ld hl,userMem
	push hl
	ld de,appBackUpScreen
	ldir
	;Now delete the RAM
	pop hl
	pop de
	push de
	B_CALL DelMem
	;now insert at the proper place
	pop hl
	pop de
	push hl
	B_CALL InsertMem
	;Copy it over
	ld hl,appBackUpScreen
	pop bc
	ldir
	ld bc,(tempWord)
	ld a,b
	or c
	jr nz,Relocation_MoveBack_Loop
	jr Shell_Redisplay
Relocation_AdjustLength:
	ld bc,768
	ld hl,(tempWord)
	ld a,h
	sub b
	jr nc,Relocation_AdjustLength_OK
	ld b,h
	ld c,l
	xor a
	ld l,a
Relocation_AdjustLength_OK:
	ld h,a
	ld (tempWord),hl
	ld h,b
	ld l,c
	ret
Relocation_Routine_End:

